import { HttpClient, HttpHeaders } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { SettingsService } from "../settings/settings.service";
import { Observable } from "rxjs";
import { QueryResult } from "../../models/graphql/result.model";

@Injectable({
  providedIn: "root"
})
export class DataService {

  constructor(
    private appsettings: SettingsService,
    private http: HttpClient
  ) {
  }

  query(query: string, variables: object = {}): Observable<QueryResult> {
    return this.http.post<QueryResult>(`${this.appsettings.getApiURL()}/api/graphql`,
      JSON.stringify({
        query, variables
      }), {
        headers: new HttpHeaders({
          "Content-Type": "application/json"
        })
      }
    );
  }

}
